//$Id: JACCPreLoadEventListener.java,v 1.5 2005/04/03 18:28:28 oneovthafew Exp $
package org.hibernate.secure;

import java.security.AccessController;

import javax.security.jacc.EJBMethodPermission;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.event.PreLoadEvent;
import org.hibernate.event.def.DefaultPreLoadEventListener;

/**
 * @author Gavin King
 */
public class JACCPreLoadEventListener extends DefaultPreLoadEventListener {

	private static final Log log = LogFactory.getLog(JACCPreLoadEventListener.class);

	public void onPreLoad(PreLoadEvent event) {
		EJBMethodPermission loadPermission = new EJBMethodPermission( 
				event.getPersister().getEntityName(),
				HibernatePermission.READ
		);
		log.debug( "checking load permission on: " + loadPermission.getName() );
		AccessController.checkPermission(loadPermission);
		super.onPreLoad(event);
	}
}
