//$Id: JACCPreUpdateEventListener.java,v 1.5 2005/04/03 18:28:28 oneovthafew Exp $
package org.hibernate.secure;

import java.security.AccessController;

import javax.security.jacc.EJBMethodPermission;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.event.PreUpdateEvent;
import org.hibernate.event.def.DefaultPreUpdateEventListener;

/**
 * @author Gavin King
 */
public class JACCPreUpdateEventListener extends DefaultPreUpdateEventListener {

	private static final Log log = LogFactory.getLog(JACCPreUpdateEventListener.class);

	public boolean onPreUpdate(PreUpdateEvent event) {
		EJBMethodPermission updatePermission = new EJBMethodPermission( 
				event.getPersister().getEntityName(),
				HibernatePermission.UPDATE
		);
		log.debug( "checking update permission on: " + updatePermission.getName() );
		AccessController.checkPermission(updatePermission);
		return super.onPreUpdate(event);
	}
}
